{*****************************************}
{***  Display of 2 tori (polyhedrons) ****}
{*****************************************}
program tori_h;
uses geograph;
 const {CAUTION: provide array_size>=nfmax   !!!}
       nfmax= 20000;  nemax=40000;    nsegmax=10;  npfmax=4;
 
 type  vts2d_pol  = array[0..npfmax] of vt2d;
       vts3d_pol  = array[0..npfmax] of vt3d;
       r_array_seg  = array[0..nsegmax] of real;
       i_array_seg  = array[0..nsegmax] of integer;
       box3d_dat = record
                   xmin,xmax,ymin,ymax,zmin,zmax : real;
                   end;
       face_dat = record
                  npf,nef : integer;
                  fp,fe : array[1..npfmax] of integer;
                  vis : boolean;
                  box : box3d_dat;
                  discentre,d : real;
                  nv : vt3d;
                  end;
       edge_dat = record
                  vis : boolean;
                  ep1,ep2,color,linew : integer;
                  end;
 var   face : array[1..nfmax] of face_dat;
       edge : array[1..nemax] of edge_dat;
       p : vts3d;     p0 : vt3d;   pdist : r_array;   error : boolean;
       n1,n2,np,nf,ne,i,k,ik,iachs,inz,ianf,i2tor,ne0 : integer;
       r1,r2,dw,cdw,sdw : real;
     {$i include/proc_zpo.pas}

{****************}
begin {main program}
   graph_on(0);
   repeat
     writeln(' ***  2 tori  *** ');    writeln;
     writeln(' n2 (>2 divisions of the large circle) ? ');  readln(n2);
     writeln(' n1 (>2 divisions of the small circle) ? ');  readln(n1);
     writeln(' 2 tori ? (yes:1, no:0) or 1 Torus ? ');      readln(i2tor);
      ne0:= 0;
      r1:= 50;  r2:= 15;
{ n1 points on small circle: }
     dw:= pi2/n1;   cdw:= cos(dw);    sdw:= sin(dw);
     put3d(r1+r2,0,0, p[1]);   put3d(r1,0,0, p0);
     for i:= 2 to n1 do rotp0y(cdw,-sdw,p0, p[i-1], p[i]);
{ remaining points of the 1. torus: }
     dw:= pi2/n2;   cdw:= cos(dw);    sdw:= sin(dw);
     for k:= 2 to n2 do
         for i:= 1 to n1 do
             begin
             ik:= i + (k-1)*n1;
             rotorz(cdw,sdw,p[ik-n1], p[ik]);
             end;
     np:= n1*n2;
     aux_torus(n1,n2,0,0,0);
     for i:= ne0+1 to ne do
	  with edge[i] do begin color:=cyan; linew:=1; end;
      ne0:= ne;
{ 2. torus:}
    if i2tor=1 then
       begin
       for i:= 1 to np do put3d(p[i].x-r1, -p[i].z, p[i].y,  p[np+i]);
       aux_torus(n1,n2,np,ne,nf);
       for i:= ne0+1 to ne do
	   with edge[i] do begin color:=blue; linew:=1; end;
       ne0:= ne;
       end;
     writeln(' np:',np);     writeln(' nf:',nf);     writeln(' ne:',ne);

     repeat
       init_centralparallel_projection(2);
	{ writeln(' coordinate axes ? (yes:1, no:0)');         readln(iachs);}
{ drawing : }
	draw_area(200,200,80,90,1);
    {   if iachs=1 then begin  cp_axes(20);  point2d(null2d,0);  end; }

       cp_lines_before_convex_faces(true,false,true);    {hiddenline-algorithm}

       draw_end ;        writeln ;
       writeln(' another projection ? (yes:1, no:0)');     readln(inz);
     until inz=0;
   writeln('new n1, n2 ?  (yes:1, no:0)'); readln(ianf);
   until ianf=0;
   graph_off;
 end.





