%{
#include <stdio.h>
#include <math.h>
#include <setjmp.h>
#include "fktdef.h"

extern double pow();
extern void Pow(), Cmul(), Psym();
extern int  Cdiv();
extern Value F_wert;		/* aktueller Funktionswert */
extern jmp_buf restart;		/* restart-Adresse fuer Fehlerfall */
Value	lv;			/* Wert des letzten berechneten Ausdrucks */
extern short F_ifk;
extern char* F_ep[];
int i, t;
static int yyerrflag;			/* error recovery flag */
%}

%union
{
   Value  val;
   Symbol *sym;
   char   *mfe;
}
%token	<val>	NUMBER PVAL
%token	<sym>	CONST VAR UNDEF BLTIN MFKT TABF
%token  <mfe>   MFKTDEF MFKTPAR FDATEI
%token		END EXIT ASSIGN ADDASS SUBASS MULASS DIVASS EXPASS LSTVAL FDEF
%token		IFTHEN LT LEQ GT GEQ EQ NEQ
%type	<val>	expr asgn logexpr

%left	'+' '-'
%left	'*' '/'
%left	UMINUS
%right	'^'

%%
list:   asgn END
      | asgn EXIT
      | mfktd END
      | mfktd EXIT
	    {  YYACCEPT; }

      | error END
      | error EXIT
	    {  yyerrok;
	       execerror("!! Syntax-Fehler !", NULL ); }

      | expr EXIT
	    { 
	       if ((F_wert.type = $1.type) == 1 )
		  F_wert.u.s = $1.u.s;  
	       else for ( i = 0; i < $1.type; i++ )
		  F_wert.u.v[i] = $1.u.v[i];


	       YYACCEPT; 
	    }
      
      | PVAL EXIT
	    {
	       if ( $1.type == -1 )
		  for ( i = 0; i <= MDIM; i++ )
		     Psym(i);
	       else if ( $1.type >= 0 && $1.type <= MDIM )
		  Psym($1.type);

	       YYACCEPT;
	    }

mfktd: VAR  MFKTDEF
	    {
	       $1->class = MFKT;
	       $1->V.type = 0;
	       $1->V.u.mf.expr = $2;
	    }

     | MFKT MFKTDEF
	    {
	       if ( $1->V.u.mf.expr )
		  free($1->V.u.mf.expr);

	       $1->V.type = 0;
	       $1->V.u.mf.expr = $2;
	    }

     | VAR  '[' MFKTPAR ']' MFKTDEF
	    {
	       $1->class = MFKT;
	       $1->V.type = 1;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.expr = $5;
	    }

     | MFKT '[' MFKTPAR ']' MFKTDEF
	    {
	       if ( & $1->V.u.mf.expr )
		  free($1->V.u.mf.expr);

	       $1->V.type = 1;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.expr = $5;
	    }

     | VAR  '[' MFKTPAR ',' MFKTPAR ']' MFKTDEF
	    {
	       $1->class = MFKT;
	       $1->V.type = 2;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.pnam[1] = *$5;  free($5);
	       $1->V.u.mf.expr = $7;
	    }

     | MFKT '[' MFKTPAR ',' MFKTPAR ']' MFKTDEF
	    {
	       if ( $1->V.u.mf.expr )
		  free($1->V.u.mf.expr);

	       $1->V.type = 2;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.pnam[1] = *$5;  free($5);
	       $1->V.u.mf.expr = $7;
	    }

     | VAR  '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF
	    {
	       $1->class = MFKT;
	       $1->V.type = 3;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.pnam[1] = *$5;  free($5);
	       $1->V.u.mf.pnam[2] = *$7;  free($7);
	       $1->V.u.mf.expr = $9;
	    }

     | MFKT '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF
	    {
	       if ( $1->V.u.mf.expr )
		  free($1->V.u.mf.expr);

	       $1->V.type = 3;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.pnam[1] = *$5;  free($5);
	       $1->V.u.mf.pnam[2] = *$7;  free($7);
	       $1->V.u.mf.expr = $9;
	    }

     | VAR  '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF
	    {
	       $1->class = MFKT;
	       $1->V.type = 4;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.pnam[1] = *$5;  free($5);
	       $1->V.u.mf.pnam[2] = *$7;  free($7);
	       $1->V.u.mf.pnam[3] = *$9;  free($9);
	       $1->V.u.mf.expr = $11;
	    }

     | MFKT '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF
	    {
	       if ( $1->V.u.mf.expr )
		  free($1->V.u.mf.expr);

	       $1->V.type = 4;
	       $1->V.u.mf.pnam[0] = *$3;  free($3);
	       $1->V.u.mf.pnam[1] = *$5;  free($5);
	       $1->V.u.mf.pnam[2] = *$7;  free($7);
	       $1->V.u.mf.pnam[3] = *$9;  free($9);
	       $1->V.u.mf.expr = $11;
	    }

asgn: VAR ASSIGN expr
	    {
	       $1->V.type = $$.type = $3.type;

	       switch( $3.type )
	       {
	       case 1:
		  $1->V.u.s  = $$.u.s  = $3.u.s;
		  break;
	       case 2: 
		  for ( i = 0; i < $1->V.type; i++ )
		     $1->V.u.v[i] = $$.u.v[i] = $3.u.v[i];

		  break;
	       }

	       if ( $1->class == UNDEF )
		  $1->class = VAR;
	    }

      | VAR ADDASS expr
	    {
	       if ( $1->class == UNDEF )
		  execerror( "undefinierte Variable", $1->name );

	       if ( $1->V.type == $3.type )
	       {
		  if (( t = $$.type = $1->V.type ) <= MDIM )
		     for ( i = 0; i < t; i++ )
			$$.u.v[i] = $1->V.u.v[i] += $3.u.v[i];
		  else
		     execerror( "Operation unzulaessig", NULL );
	       }
	       else if ( $1->V.type == 2 && $3.type == 1 )
	       {
		  $$.u.v[0] = $1->V.u.v[0] += $3.u.s;
		  $$.u.v[1] = $1->V.u.v[1];
		  $$.type   = $1->V.type;
	       }
	       else
		  execerror( "unzulaessige Typkombination", NULL );
	    }

      | VAR SUBASS expr
	    {
	       if ( $1->class == UNDEF )
		  execerror( "undefinierte Variable", $1->name );

	       if ( $1->V.type == $3.type )
	       {
		  if (( t = $$.type = $1->V.type ) <= MDIM )
		     for ( i = 0; i < t; i++ )
			$$.u.v[i] = $1->V.u.v[i] -= $3.u.v[i];
		  else
		     execerror( "Operation unzulaessig", NULL );
	       }
	       else if ( $1->V.type == 2 && $3.type == 1 )
	       {
		  $$.u.v[0] = $1->V.u.v[0] -= $3.u.s;
		  $$.u.v[1] = $1->V.u.v[1];
		  $$.type   = $1->V.type;
	       }
	       else
		  execerror( "unzulaessige Typkombination", NULL );
	    }

      | VAR MULASS expr
	    {
	       if ( $1->class == UNDEF )
		  execerror( "undefinierte Variable", $1->name );

	       if ( $1->V.type == $3.type )
	       {
		  switch ( $1->V.type )
		  {
		  case 1:
		     $1->V.u.s *= $3.u.s;
		     break;

		  case 2:
		     Cmul( $1->V.u.v, $3.u.v, $1->V.u.v );
		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }
	       else 
	       {
		  switch( $3.type )
		  {
		  case 1:
		     if (( t = $1->V.type ) == 2 )
			for ( i = 0; i < t; i++ )
			   $1->V.u.v[i] *= $3.u.s;
		     else
			execerror( "Operation unzulaessig", NULL );

		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }

	       assval( &$$, $1->V.type, &$1->V );
	    }

      | VAR DIVASS expr
	    {
	       if ( $1->class == UNDEF )
		  execerror( "undefinierte Variable", $1->name );

	       if ( $1->V.type == $3.type )
	       {
		  switch ( $1->V.type )
		  {
		  case 1:
		     $1->V.u.s /= $3.u.s;
		     break;

		  case 2:
		     if ( !Cdiv( $1->V.u.v, $3.u.v, $1->V.u.v ))
			execerror( "Division durch 0", NULL );

		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }
	       else 
	       {
		  switch( $3.type )
		  {
		  case 1:
		     if (( t = $1->V.type ) == 2 )
			if ( abs($3.u.s) > EPSD )
			   for ( i = 0; i < t; i++ )
			      $1->V.u.v[i] /= $3.u.s;
			else
			   execerror( "Division durch 0", NULL );
		     else
			execerror( "Operation unzulaessig", NULL );

		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }

	       assval( &$$, $1->V.type, &$1->V );
	    }

      | VAR EXPASS expr
	    {
	       if ( $1->class == UNDEF )
		  execerror( "undefinierte Variable", $1->name );

	       if ( $1->V.type == $3.type && $1->V.type <= MDIM )
	       {
		  $$.type = 2;
		  Pow(&$$,&$1->V,&$3);
		  assval(&$1->V,$$.type,&$$);
	       }
	       else
		  execerror( "Operation unzulaessig", NULL );
	    }

      | VAR FDEF FDATEI
	    {
	       F_tdef( $1, $3 );    /* Definition einer tabellierten Funktion */
	    }


expr:   NUMBER
      | CONST
	    {
	       assval( &$$, $1->V.type, &$1->V );
	    }

      | LSTVAL
	    {
	       assval(&$$,lv.type,&lv);
	    }
      | VAR
	    {
	       if ( $1->class == UNDEF )
		  execerror( "undefinierte Variable", $1->name );

	       assval( &$$, $1->V.type, &$1->V );
	    }

      | asgn

      | '(' expr ')'
	    {
	       assval( &$$, $2.type, &$2 );
	    }

      | '-' expr %prec UMINUS
	    {
	       t = ( $$.type = $2.type );

	       for ( i = 0; i < t; i++ )
		  $$.u.v[i] = -$2.u.v[i];
	    }

      | MFKT
	    {
	       F_ep[++F_ifk] = $1->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if (($$.type = F_wert.type) == 1 )
		  $$.u.s = F_wert.u.s;  
	       else for ( i = 0; i < $$.type; i++ )
		  $$.u.v[i] = F_wert.u.v[i];
	    }

      | MFKT '(' expr ')'
	    {
	       char p1;
	       Psymbol *ps;

	       p1 = $1->V.u.mf.pnam[0];
	       ps = Pinstall(p1, &$3);
	       F_ep[++F_ifk] = $1->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if (($$.type = F_wert.type) == 1 )
		  $$.u.s = F_wert.u.s;  
	       else for ( i = 0; i < $$.type; i++ )
		  $$.u.v[i] = F_wert.u.v[i];

	       Deinstall(p1);
	    }

      | MFKT '(' expr ',' expr ')'
	    {
	       char p1[2];
	       Psymbol *ps;

	       for ( i = 0; i < 2; i++ )
		  p1[i] = $1->V.u.mf.pnam[i];

	       ps = Pinstall(p1[0], &$3);
	       ps = Pinstall(p1[1], &$5);
	       F_ep[++F_ifk] = $1->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if (($$.type = F_wert.type) == 1 )
		  $$.u.s = F_wert.u.s;  
	       else for ( i = 0; i < $$.type; i++ )
		  $$.u.v[i] = F_wert.u.v[i];

	       for ( i = 0; i < 2; i++ )
		  Deinstall(p1[i]);
	    }

      | MFKT '(' expr ',' expr ',' expr ')'
	    {
	       char p1[3];
	       Psymbol *ps;

	       for ( i = 0; i < 3; i++ )
		  p1[i] = $1->V.u.mf.pnam[i];

	       ps = Pinstall(p1[0], &$3);
	       ps = Pinstall(p1[1], &$5);
	       ps = Pinstall(p1[2], &$7);
	       F_ep[++F_ifk] = $1->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if (($$.type = F_wert.type) == 1 )
		  $$.u.s = F_wert.u.s;  
	       else for ( i = 0; i < $$.type; i++ )
		  $$.u.v[i] = F_wert.u.v[i];

	       for ( i = 0; i < 3; i++ )
		  Deinstall(p1[i]);
	    }

      | MFKT '(' expr ',' expr ',' expr ',' expr ')'
	    {
	       char p1[4];
	       Psymbol *ps;

	       for ( i = 0; i < 4; i++ )
		  p1[i] = $1->V.u.mf.pnam[i];

	       ps = Pinstall(p1[0], &$3);
	       ps = Pinstall(p1[1], &$5);
	       ps = Pinstall(p1[2], &$7);
	       ps = Pinstall(p1[3], &$9);
	       F_ep[++F_ifk] = $1->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if (($$.type = F_wert.type) == 1 )
		  $$.u.s = F_wert.u.s;  
	       else for ( i = 0; i < $$.type; i++ )
		  $$.u.v[i] = F_wert.u.v[i];

	       for ( i = 0; i < 4; i++ )
		  Deinstall(p1[i]);
	    }

      | BLTIN '(' expr ')'
	    {
	       if (($$.type = $1->V.type) == MULTPAR )
		  $$.type = 1;
	       else if ( $$.type != 1 )
		  execerror( $1->name, "unzulaessige Parameteranzahl" );

	       (*($1->V.u.f))( &$$, &$3 );
	    }

      | BLTIN '(' expr ',' expr ')'
	    {
	       if (($$.type = $1->V.type) == MULTPAR )
		  $$.type = 2;
	       else if ( $$.type != 2 )
		  execerror( $1->name, "unzulaessige Parameteranzahl" );

	       (*($1->V.u.f))( &$$, &$3, &$5 );
	    }

      | BLTIN '(' expr ',' expr ',' expr ')'
	    {
	       if (($$.type = $1->V.type) == MULTPAR )
		  $$.type = 3;
	       else if ( $$.type != 3 )
		  execerror( $1->name, "unzulaessige Parameteranzahl" );

	       (*($1->V.u.f))( &$$, &$3, &$5, &$7 );
	    }

      | BLTIN '(' expr ',' expr ',' expr ',' expr ')'
	    {
	       if (($$.type = $1->V.type) == MULTPAR )
		  $$.type = 4;
	       else if ( $$.type != 4 )
		  execerror( $1->name, "unzulaessige Parameteranzahl" );

	       (*($1->V.u.f))( &$$, &$3, &$5, &$7, &$9 );
	    }

      | TABF '(' expr ',' expr ',' expr ')'
	    {
	       F_tval( &$$, $1, &$3, &$5, &$7 );  /* Auswerten einer tabellierten Funktion */
	    }

      | expr '+' expr
	    {
	       if ( $1.type == $3.type )
	       {
		  switch ( t = $$.type = $1.type )
		  {
		  case 1:
		     $$.u.s = $1.u.s + $3.u.s;
		     break;
		  case 2:
		     for ( i = 0; i < t; i++ )
			$$.u.v[i] = $1.u.v[i] + $3.u.v[i];

		     break;
		  default:
		     execerror( "undefinierte Operation", NULL );
		  }
	       }
	       else
	       {
		  Value v1, v2;
		  short t1, t2;

		  if ( $1.type < $3.type )
		  {
		     t1 = $1.type;  t2 = $3.type;
		     assval( &v1, t1, &$1 );
		     assval( &v2, t2, &$3 );
		  }
		  else
		  {
		     t1 = $3.type;  t2 = $1.type;
		     assval( &v1, t1, &$3 );
		     assval( &v2, t2, &$1 );
		  }

		  switch ( t1 )
		  {
		  case 1:
		     if ( t2 == 2 )
		     {
			$$.u.v[0] = v1.u.s + v2.u.v[0];
			$$.u.v[1] = v2.u.v[1];
			$$.type   = t2;
		     }
		     else
			execerror( "unzulaessige Typkombination", NULL );

		     break;

		  default:
		     execerror( "unzulaessige Typkombination", NULL );
		  }
	       }
	    }

      | expr '-' expr
	    {
	       if ( $1.type == $3.type )
	       {
		  switch ( t = $$.type = $1.type )
		  {
		  case 1:
		     $$.u.s = $1.u.s - $3.u.s;
		     break;
		  case 2:
		     for ( i = 0; i < t; i++ )
			$$.u.v[i] = $1.u.v[i] - $3.u.v[i];

		     break;
		  default:
		     execerror( "undefinierte Operation", NULL );
		  }
	       }
	       else
	       {
		  Value v1, v2;
		  short t1, t2;

		  if ( $1.type < $3.type )
		  {
		     t1 = $1.type;  t2 = $3.type;
		     assval( &v1, t1, &$1 );
		     assval( &v2, t2, &$3 );
		  }
		  else
		  {
		     t1 = $3.type;  t2 = $1.type;
		     assval( &v1, t1, &$3 );
		     assval( &v2, t2, &$1 );
		  }

		  switch ( t1 )
		  {
		  case 1:
		     if ( t2 == 2 )
		     {
			$$.u.v[0] = v1.u.s - v2.u.v[0];
			$$.u.v[1] = v2.u.v[1];
			$$.type   = t2;
		     }
		     else
			execerror( "unzulaessige Typkombination", NULL );

		     break;

		  default:
		     execerror( "unzulaessige Typkombination", NULL );
		  }
	       }
	    }

      | expr '*' expr
	    {
	       if ( $1.type == $3.type )
	       {
		  switch ( t = $$.type = $1.type )
		  {
		  case 1:
		     $$.u.s = $1.u.s * $3.u.s;
		     break;

		  case 2:
		     Cmul( $1.u.v, $3.u.v, $$.u.v );
		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
 		  }
	       }
	       else
	       {
		  Value v1, v2;
		  short t1, t2;

		  if ( $1.type < $3.type )
		  {
		     t1 = $1.type;  t2 = $3.type;
		     assval( &v1, t1, &$1 );
		     assval( &v2, t2, &$3 );
		  }
		  else
		  {
		     t1 = $3.type;  t2 = $1.type;
		     assval( &v1, t1, &$3 );
		     assval( &v2, t2, &$1 );
		  }

		  if ( t1 == 1 && t2 == 2 )
		  {
		     for ( i = 0; i < t2; i++ )
			$$.u.v[i] = v1.u.s * v2.u.v[i];

		     $$.type   = t2;
		  }
		  else
		     execerror( "unzulaessige Typkombination", NULL );
	       }
	    }

      | expr '/' expr
	    {
	       if ( $1.type == $3.type )
	       {
		  switch ( t = $$.type = $1.type )
		  {
		  case 1:
		     $$.u.s = $1.u.s / $3.u.s;
		     break;

		  case 2:
		     if ( !Cdiv( $1.u.v, $3.u.v, $$.u.v ))
			execerror( "Division durch 0", NULL );
		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
 		  }
	       }
	       else if ( $1.type == 1 && $3.type == 2 ||
			 $1.type == 2 && $3.type == 1 )
	       {
		  Value v1, v2;

		  assval( &v1, 2, &$1 );
		  assval( &v2, 2, &$3 );

		  if ( $1.type == 1 )
		     v1.u.v[1] = .0;
		  else
		     v2.u.v[1] = .0;

		  if ( !Cdiv( v1.u.v, v2.u.v, $$.u.v ))
		     execerror( "Division durch 0", NULL );

		  $$.type = 2;
	       }
	       else
		  execerror( "unzulaessige Typkombination", NULL );
	    }

      | expr '^' expr
	    { 
	       $$.type = 2;
	       Pow( &$$, &$1, &$3 );
	    }
      | IFTHEN logexpr ',' expr ',' expr '}'
	    {
	       if ( $2.type == -1 )
		  if ( $2.u.lv )
		     assval( &$$, $4.type, &$4 );
		  else
		     assval( &$$, $6.type, &$6 );
	       else
		  execerror( "kein logischer Ausdruck", NULL );
	    }

logexpr: '(' logexpr ')'
	    {
	       assval( &$$, $2.type, &$2 );
	    }
	 |  expr LT expr
	    {
	       if ( $1.type == 1 && $1.type == $3.type )
	       {
		  $$.u.lv = ( $1.u.s < $3.u.s );
		  $$.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    }
	 |  expr LEQ expr
	    {
	       if ( $1.type == 1 && $1.type == $3.type )
	       {
		  $$.u.lv = ( $1.u.s <= $3.u.s );
		  $$.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    }
	 |  expr GT expr
	    {
	       if ( $1.type == 1 && $1.type == $3.type )
	       {
		  $$.u.lv = ( $1.u.s > $3.u.s );
		  $$.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    }
	 |  expr GEQ expr
	    {
	       if ( $1.type == 1 && $1.type == $3.type )
	       {
		  $$.u.lv = ( $1.u.s >= $3.u.s );
		  $$.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    }
	 |  expr EQ expr
	    {
	       if ( $1.type == 1 && $1.type == $3.type )
	       {
		  $$.u.lv = ( $1.u.s == $3.u.s );
		  $$.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    }
	 |  expr NEQ expr
	    {
	       if ( $1.type == 1 && $1.type == $3.type )
	       {
		  $$.u.lv = ( $1.u.s != $3.u.s );
		  $$.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    }
%%

void assval( v1, t, v2 )
Value *v1, *v2;
short t;
{
   short i;

   if ( t == 1 )
      v1->u.s = v2->u.s;
   else
      for ( i = 0; i < t; i++ )
	 v1->u.v[i] = v2->u.v[i];

   v1->type = t;
}

/* Retten der globalen Parser-Daten bei Rekursion */

#define MAXRD 20
static int * yy_int[MAXRD], yy_actrd = -1;
static YYSTYPE * yy_typ[MAXRD];
extern int yynerrs;
extern YYSTYPE yyv[];

yypush(sdepth)
int   sdepth;
{
   if ( yy_actrd < MAXRD )
   {
      register short i;
      register int *pint;
      register YYSTYPE *ptyp;

      ++yy_actrd;
      pint = yy_int[yy_actrd] = (int *) emalloc( sizeof(int)*4 );
      ptyp = yy_typ[yy_actrd] = (YYSTYPE *) emalloc( sizeof(YYSTYPE)*(2+sdepth));

      *pint = yychar;  *(++pint) = yynerrs;  *(++pint) = (int) yyerrflag;
      *(++pint) = sdepth;
      *ptyp = yyval;   *(++ptyp) = yylval;

      for ( i=0; i < sdepth; i++ )
	 *(++ptyp) = yyv[i];
   }
   else
      execerror( "!! Max. Verschachtelungsstiefe ueberschritten", (char *)0);
}

yypop()
{
   if ( yy_actrd >= 0 )
   {
      register short i;
      register int *pint;
      register YYSTYPE *ptyp;
      int sdepth;

      pint = yy_int[yy_actrd];
      ptyp = yy_typ[yy_actrd];

      yychar = *pint;  yynerrs = *(++pint);  yyerrflag = (short) *(++pint);
      sdepth = *(++pint);
      yyval  = *ptyp;  yylval  = *(++ptyp);

      for ( i=0; i < sdepth; i++ )
	yyv[i]  = *(++ptyp);

      free(yy_typ[yy_actrd]);
      free(yy_int[yy_actrd]);
      yy_typ[yy_actrd] = NULL;
      yy_int[yy_actrd] = NULL;
      --yy_actrd;
   }
}

yyerror( s )
char *s;
{
   warning( s, NULL );
}

warning( s, t )
char *s, *t;
{
   fprintf( stderr, "Fkt: %s", s );

   if ( t )
      fprintf( stderr, " - %s", t );

   fprintf( stderr, "\n" );
   longjmp(restart,0);
}

yywrap()
{
   return(1);
}
