%{
#include "fktdef.h"
#include "f_parse.h"

extern Psymbol *Plookup();

extern int *S_tab;
static short mfkdef = 0;	/* Makro/Funktions-Definition aktiv ? */
extern short mfkpar;            /* Makro/Funktions-Parameter aktiv ? */
%}

D	[0-9]
L	[a-zA-Z]
LDU	({L}|{D}|_)
fzahl	({D}+\.?)|({D}*\.{D}+)
ezahl	{fzahl}[eE][+\-]?{D}+

%%
[ \t]	{ ; }		/* skip blanks and tabs */

{fzahl}|{ezahl} {
	sscanf( (char*) yytext, "%le", &yylval.val.u.s );
	yylval.val.type = 1;
	return NUMBER;
	}

{L}{LDU}* {
	Symbol *s;

	if ( yyleng == 1 )
	{
	   short  i;
	   extern short F_dim;
	   extern char Param[];
	   extern double Parval[];

	   if ( mfkdef )
	   {
	      yylval.mfe = emalloc(1);
	      *yylval.mfe = yytext[0];
	      return MFKTPAR;
	   }
	   else if ( mfkpar )
	   {
	      Psymbol *ps;

	      if (ps = Plookup(yytext[0]))
	      {
		 if ((yylval.val.type = ps->pval.type ) == 1 )
		    yylval.val.u.s = ps->pval.u.s;
		 else
		    for ( i=0; i < yylval.val.type; i++ )
		       yylval.val.u.v[i] = ps->pval.u.v[i];

	         return NUMBER;
	      }
	   }

	   for ( i = 0; i < F_dim; i++ )
	      if ( yytext[0] == Param[i] )
	      {
	         yylval.val.u.s = Parval[i];
		 yylval.val.type = 1;
		 return NUMBER;
	      }
	}

	if ( (s=lookup( yytext )) == 0 )
	   s = install( yytext, UNDEF, 0, 0 );

	yylval.sym = s;
	return ( s->class == UNDEF ? VAR : s->class );
	}

{LDU}+"."{L}{L} {
	    yylval.mfe = emalloc(yyleng);
	    strcpy(yylval.mfe, yytext);
	    return FDATEI;
        }

":="	{ return ASSIGN; }
"+="	{ return ADDASS; }
"-="	{ return SUBASS; }
"*="	{ return MULASS; }
"/="	{ return DIVASS; }
"^="	{ return EXPASS; }
":<"	{ return FDEF; }
"::".*";" { yytext[yyleng-1] = '#';
	    yylval.mfe = emalloc(yyleng-2);
	    strcpy(yylval.mfe, &yytext[2]);
	    return MFKTDEF; }
"["	{ mfkdef = 1; return yytext[0]; }
"]"	{ mfkdef = 0; return yytext[0]; }
";"	{ return END;  }
"#"	{ return EXIT; }
"%"	{ return LSTVAL; }
"?f"	{ yylval.val.type = 0; return PVAL; }
"?s"	{ yylval.val.type = 1; return PVAL; }
"?c"	{ yylval.val.type = 2; return PVAL; }
"?a"	{ yylval.val.type = -1; return PVAL; }
"If{"	{ return IFTHEN; }
"<"	{ return LT; }
"<="	{ return LEQ; }
">"	{ return GT; }
">="	{ return GEQ; }
"=="	{ return EQ; }
"~="	{ return NEQ; }
.	{ return yytext[0]; }
