{*****************************************************************************}
{*****************************************************************************}

Program ppatch(input,output);
uses geograph,hiddenl;
(*
{fuer Hiddenline:}

const {Achtung: es muss  array_size>=nfmax  sein  !!!}
       nfmax= 10000;  nemax=20000;    nsegmax=10;  npfmax=10;

type   vts2d_pol  = array[0..npfmax] of vt2d;
       vts3d_pol  = array[0..npfmax] of vt3d;
       r_array_seg  = array[0..nsegmax] of real;
       i_array_seg  = array[0..nsegmax] of integer;
       box3d_dat = record
                   xmin,xmax,ymin,ymax,zmin,zmax : real;
                   end;
       face_dat = record
                  npf,nef : integer;
                  fp,fe : array[1..npfmax] of integer;
                  vis : boolean;
                  box : box3d_dat;
                  discentre,d : real;
                  nv : vt3d;
                  end;
       edge_dat = record
                  vis : boolean;
                  ep1,ep2,color,linew : integer;
                  end;

var    ne,nf,np: integer;  {Anzahl der Kanten, Facetten,Punkte}
       p    : vts3d;       {Punkte des Polyeders} 
       face : array[1..nfmax] of face_dat;
       edge : array[1..nemax] of edge_dat;
       pdist: r_array;     {pdist[i]: Abstand d. i-ten Punktes von d. Bildeb.} 
       error,oriented_faces,is_permitted,newstyles: boolean;
*)

const
	npmax= 16000;
type
  fname_string=string;
var

  p_table  : array[1..npmax] of integer;
  np_table : integer;

  ppname   : fname_string;

  i,iaus,
  g_mode             : integer;

  zf_breite,zf_hoehe,
  zf_x0,zf_y0,
  zf_faktor          : Real;

{****************}

{###################################################################}
{****  auxiliary procs for generating OFFfiles used for GEOMVIEW ***}
{*******************************************************************}

{*****}
var offdatei : text;
{*****}
   
procedure open_offdatei;
{ for OFF-file }
 var  datei : string;
 begin
   writeln('name of OFF-File (*.off)');
   readln(datei);
   assign(offdatei,datei);
   rewrite(offdatei);
 end; { open_offdatei }
{*************}

procedure close_offdatei;
 begin
   Close(offdatei);
 end;
{************}

procedure write_nangles_to_offfile;
var i,k : integer;
begin
 open_offdatei;
 writeln(offdatei, 'OFF');
 writeln(offdatei,np,' ',nf,' ',0);
 for i:= 1 to np do with p[i] do
           writeln(offdatei,'   ',x:3:5,' ',y:3:5,' ',z:3:5);
 for i:= 1 to nf do
    with face[i] do
         begin
         write(offdatei,npf,'  ');
         for k:= 1 to npf do write(offdatei,fp[k]-1,' ');
         writeln(offdatei,' ');
	 end;   
 close_offdatei;
end;  { write_nangles_to_offdatei }
{#####################################################################}


function compare_point_with_list(p0:vt3d;index:integer):integer;
var
  p1,p2,d : vt3d;

begin
  p1  := p0; p2 := p[index];
  diff3d(p1,p2,d);
  if abs3d(d)<=eps4 then compare_point_with_list := 0
  else
    if (p1.x < p2.x) or
      ((p1.x = p2.x) and (p1.y < p2.y)) or
      ((p1.x = p2.x) and (p1.y = p2.y) and (p1.z < p2.z))
      then  compare_point_with_list := -1
      else  compare_point_with_list :=  1;

end;

function p_table_bsearch(key : vt3d;
                         base : integer;
                         nelem : integer;
                         var pos : integer) :boolean;

var found: boolean;  left,right,middle: integer;   i,d : integer;
begin
  if nelem=0 then begin p_table_bsearch:= false; pos:= 1; end
  else           { binaeres Suchen }
   begin
      left:= 1;  right:= nelem;  found := false;
      repeat
      middle:= (left+right) div 2;
      d:=compare_point_with_list(key,p_table[base+(middle-1)]);
      case d of
        0 : found := true;
       -1 : right := middle-1;
        1 : left  := middle+1;
      end;
      until found or (left>right);

    if d = 1 then pos := middle + 1 else pos := middle;
    p_table_bsearch:=found;
  end;
end;

procedure read_ppfile(fname:fname_string);
var
  f : text;
  ds : string[80];
  dr : real;
  p0  : vt3d;
  npp,pos,j,i : integer;
  ds1 : string[6];
begin
 assign(f,fname);
   reset(f);  
{   reset(f,fname);  }
  while not eof(f) do
  begin 
    repeat 
      Read(f,ds1);
      if ds1 <> 'ppatch' then Readln(f);   
    until ds1='ppatch';
    ReadLn(f,npp);
    nf := nf + 1;
    face[nf].npf := npp;
    face[nf].nef := npp;
    for i := 1 to npp do
    begin
      readln(f,p0.x,p0.y,p0.z,dr,dr,dr);
      if p_table_bsearch(p0,1,np_table,pos)
      then
        face[nf].fp[i] := p_table[pos]
      else
      begin      {neuer Punkt}
        np := np + 1; p[np]:=p0;
        face[nf].fp[i] := np;
        for j := np_table downto pos do p_table[j+1] := p_table[j];
        p_table[pos] := np;
        np_table := np_table + 1;
      end;

    end;
  end;
end;

{****************}

begin {Hauptprogramm}

   Writeln('*** ppatch : displaying PPAtch-Files, generated bei "fgen"  ***');
   Writeln;
   Writeln('(fgen: SCHMIDT-polygonization "cutting cubes",');
   writeln('       The Visual Comp. 10, p101-115)');   
   writeln;
   Writeln('++ name of PPAtch-file ?: (*.ppa)'); Readln(ppname);

   writeln;
   writeln('*** drawing area ***');

   writeln('++ width, height, origin (x0,y0), scalefactor: ');
   Readln(zf_breite, zf_hoehe, zf_x0, zf_y0, zf_faktor);

   init_central_projection;


   writeln('++ output: 0 -> screen only, 1 -> PLD, 2 -> OFF');
   readln(iaus);
   if iaus=1 then g_mode:=1 else g_mode:=0;

   graph_on(g_mode);

 { Zaehlvariablen initialisieren }
  np := 0;   nf := 0;   ne := 0;
   np_table := 0;

   read_ppfile(ppname);

   writeln('-- PPatch-File read');
   writeln('   np:',np);     writeln('   nf:',nf);

   aux_polyhedron;       
   writeln('-- edges generated');
   writeln('   np:',np);     writeln('   nf:',nf);     writeln('   ne:',ne);


   Draw_Area(zf_breite,zf_hoehe,zf_x0,zf_y0,zf_faktor);           { Zeichenflaeche }

   cp_lines_before_convex_faces(false,false,false);

   draw_end;

{generates offfile for GEOMVIEW:}
   if iaus=2 then write_nangles_to_offfile;

   
   graph_off;


 end.

